import requests
import os

## This Script is to update the Polling enable/disable for interfaces in bulk. 

## Credentials for CAPM - Production

user = <Userid>    #Enter the CAPM Username
pwd = <Password>    #Enter the CAPM Password

success_count = 0
failure_count = 0

headers = {'Content-Type': 'application/xml'}

xml_enable = """<Pollable version="1.1.1">
			<IsPollEnabled>true</IsPollEnabled>
		 </Pollable>"""

xml_disable = """<Pollable version="1.1.1">
			<IsPollEnabled>false</IsPollEnabled>
		 </Pollable>"""

# Input the File name which has interface ids to be enabled/disabled for polling. The Ids are in single column with multiple rows as below
#<id1>
#<id2>
#..
#<idn>

while True:     # To check if the file exists
    
    inputfilename = input("Type input file which has interface ids : ")
    path = <path> + inputfilename             # Replace <path> with the path the file will be stored at.
    

    try:
    	
        if os.path.isfile(path):
        	
        	#file exists
        	break
        else:
        	print("Sorry, file not found, please enter correct name")

    except:
        print("Sorry, file not found, please enter correct name")
        
        continue

while True: # To check if correct keyword , enable/disable.
    
    action = input("Do you want to enable or disable polling (enter 'enable' or 'disable') : ")

    try:
    	
        if action in ('enable','disable'):
        	
        	#keyword matches
        	break
        else:
        	print("please type either 'enable' or 'disable'")

    except:
        print("Sorry, incorrect input")
        
        continue

outputfilename = input("Type output file to log : ")

input = open(inputfilename, "r")  
output = open(outputfilename,"w+")

if action == 'enable':
	xml = xml_enable
else:
	xml = xml_disable

data = input.readlines() # Read each id in sequence

#print(len(data))

for line in data :

	url = "http://<DAIP>:8581/rest/pollable/" + line.strip()               # Replace <DAIP> with the your DAIP
	r = requests.put(url, data = xml, auth=(user,pwd), headers = headers)

	if 'success' in r.text:
		success_count=success_count + 1
	else:
		failure_count = failure_count + 1
	
	status = " Interface : " + line.strip() + " | " + str(r.status_code) + " | " + r.text + "\n"
	
	output.write(status)
	
print("Total Interfaces to be Updated : " , len(data))
print("Successfully done : ", success_count)
print("Failed to Update : ", failure_count)
print("Details logged to file : ", outputfilename)

input.close()  